#include "Main.h"
void main ( void )
{
	long Rot = 0; // # of rotations
	long Delay = 0; // Delay between pulses
	long Period = 0; // Strobe Period (milliseconds)
	long Cycle = 0; // Number of cycles
	float RPM = 0; // Number of Revolutions Per Minute (RPM)
	float Period_In_Seconds = 0;
	float Frequency = 0.0; // Strobe Light Frequency
	int Power_Switch = 1; // Bumper Switch Input
	int Toggle = 1; // Toggle On/Off
	// Control up to eight strobe lights
	// Start and Preset encoder
	StartQuadEncoder ( 1 , 10 , 0 ) ; // Start the Quadrature Optical Encoder
	PresetQuadEncoder ( 1 , 10 , 0) ; // Preset Quadrature Optical Encoder to 0
 
	while ( 1 )
	{
		Power_Switch = GetDigitalInput ( 12 ) ; // Toggle On/Off using VEX bumper switch or pushbutton switch
		if ( Power_Switch == 0 ) // Toggle the switch state
		{
			Toggle *= -1 ; // Change the toggle state
			Wait ( 25 ) ; // Debounce the button
		}
 
		//Period = GetAnalogInput ( 11 ) ;   // Read the VEX Potentiometer
		Period = GetQuadEncoder ( 1 , 10 ) ; // Get the latest Quadrature Optical Encoder counts 
		                                     // to set the Strobe Light Period
		//PrintToScreen ( "Period = %d\n" , (int)Period ) ; // Display value read from quadrature encoder
		if ( Period > 0 ) // Check if Period is negative
		{
			if ( (Cycle++ % 25) == 0 ) // Display Period every 25 cycles to improve realtime performance
			{
				Period_In_Seconds =(float) Period / 1000.0 ; // Compute Period in units of seconds
				Frequency = 1.0 / Period_In_Seconds ; // Compute Strobe Light Frequency
				RPM = Frequency * 60.0 ; // Compute RPM from current strobe light Frequency
				PrintToScreen ( "RPM = %d\n" , (int)RPM ) ; // Display current RPM measured by strobe light
			}
			if ( Toggle >= 0 ) // Strobe Light is On
			{
				SetDigitalOutput ( 2 , 1 ) ; // Turn Flash #1 ON
				SetDigitalOutput ( 3 , 1 ) ; // Turn Flash #2 ON
				SetDigitalOutput ( 4 , 1 ) ; // Turn Flash #3 ON
				SetDigitalOutput ( 5 , 1 ) ; // Turn Flash #4 ON
				SetDigitalOutput ( 6 , 1 ) ; // Turn Flash #5 ON
				SetDigitalOutput ( 7 , 1 ) ; // Turn Flash #6 ON
				SetDigitalOutput ( 8 , 1 ) ; // Turn Flash #7 ON
				SetDigitalOutput ( 9 , 1 ) ; // Turn Flash #8 ON
				Wait ( Period/2 ) ;
				SetDigitalOutput ( 2 , 0 ) ; // Turn Flash #1 OFF
				SetDigitalOutput ( 3 , 0 ) ; // Turn Flash #2 OFF
				SetDigitalOutput ( 4 , 0 ) ; // Turn Flash #3 OFF
				SetDigitalOutput ( 5 , 0 ) ; // Turn Flash #4 OFF
				SetDigitalOutput ( 6 , 0 ) ; // Turn Flash #5 OFF
				SetDigitalOutput ( 7 , 0 ) ; // Turn Flash #6 OFF
				SetDigitalOutput ( 8 , 0 ) ; // Turn Flash #7 OFF
				SetDigitalOutput ( 9 , 0 ) ; // Turn Flash #8 OFF
				Wait ( Period/2 ) ;
			}
		}
	} 
}